#include <SoftwareSerial.h>
#include "Minitel.h"
#include "MyGSM.h"

Minitel m(52,53);			//Definition pour le Serial du Minitel
MyGSM MyGSM(8);

void saisieNum(char *num);
void saisiePin(char *pin);
void saisieTxt(char *txt);
void send_sms();
void enter_pin();
void call_number();

// CAYE PAS BIEN ET JMEN FOUT !
char rep[50];
char Operator[50];
char mess_ok[50];

void setup()
{
	/****Init Shield GPRS Hardware mode*****/
	Serial.begin(19200);
	Serial1.begin(19200);
	Serial.write(27);       // ESC command
	Serial.print("[2J");    // clear screen command
	Serial.println();
	Serial.println("***********************************");
	Serial.println("Debug ATM");
	/****Simulation ON/OFF*****/
	MyGSM.initShield();
	Serial.print("[*] Shield Power state : ");
	Serial.print(MyGSM.flagOn);
	m.clearScreen();
	m.textMode();
	m.textColor(WHITE);
	m.bgColor(BLACK);

	m.text("         Smartphone Minitel V1         ", 1, 1);
	/**** check du pin *****/
	MyGSM.send_AT_cmd("AT+CPIN?\r", rep);
	if (strstr(rep, "READY") == NULL) {
		m.text("[ ] Check for pin lock... ", 2, 3);
		m.text("Enter PIN code : ", 2, 4);
		enter_pin();

	}
	m.text("[*] PIN code is good ! ", 2, 3);

	m.text("[ ]", 2, 5); 
	m.blink();
	m.text("Waiting for Auth Network .....", 6, 5);
	
	MyGSM.send_AT_cmd("AT+COPS?\r", rep);
	char *token, *endtoken;
	token = strchr(rep, '\"');
	token++;
	endtoken = strchr(token, '\"');
	*endtoken = '\0';
	sprintf(mess_ok, "You are connected to %s", token);
//	strcpy(mess_ok, "You are connected to ");
//	strcat(mess_ok, token);
	sprintf(Operator, "Operator : %s", token);
	m.noBlink();
	m.text("[*]", 2, 5);
	m.text(mess_ok, 5, 5);
	delay(2000);
	MyGSM.send_AT_cmd("AT+CGREG?\r\r", rep);
	
	delay(1000);
}

void loop()
{
	m.clearScreen();
	m.textMode();
	m.textColor(WHITE);
	m.bgColor(RED);
	m.text("         Smartphone Minitel V1         ", 1, 1);
	m.text(Operator, 1, 23);
	m.bgColor(BLACK);
	m.text("1 - Send SMS", 4, 5 );
	m.text("2 - Read SMS", 4, 6 );
	m.text("3 - Call a number", 4, 8);
	m.text("5 - Address Book", 4, 10 );
	
	while(1) {
		
		MyGSM.send_AT_cmd("", rep);
		if(MyGSM.sortRecv(rep, "NO CARRIER") == true) {
			return loop();
		}
		
		if(MyGSM.sortRecv(rep, "RING") == true){

			if(MyGSM.sortRecv(rep, "+CLIP:") == true){
				char *token, *endtoken;
				token = strchr(rep, ': "');
				token++;
				endtoken = strchr(token, '\"');
				*endtoken = '\0';
				sprintf(mess_ok, "From : %s", token);
				m.clearScreen();
				m.textMode();
				m.textColor(WHITE);
				m.bgColor(RED);
				m.text(" CALL INCOMMING .... ", 4, 1);
				m.bgColor(BLACK);
				m.text(mess_ok, 2, 4);
				m.text("1 - to answer", 2, 5);
				m.text("2 - to close", 2, 6);
				if(m.available()>0) {
					char key = NULL;
					key = m.getKey();
					switch(key) {
						case '1':
							MyGSM.send_AT_cmd("ATA\r", rep);
							break;
						case '2':
							MyGSM.send_AT_cmd("ATH\r", rep);
							break;
					}
						
				}
				
			}
			
		}
				
		if(m.available()>0) {
			char key = NULL;
			// Obligation de lire 2 buffer en cas de touche Menu
			key = m.getKey();
			switch(key) {
				case '1':
					send_sms();
					break;
				
				case '2':
					break;
				
				case '3':
					call_number();
					break;
			}
		}
	}
	
	delay(1000);

	
}

void enter_pin()
{
	char pin[5];
	char at_pin[12];
	saisiePin(pin);
	sprintf(at_pin, "AT+CPIN=%s\r", pin);
	Serial.print(pin);
	MyGSM.send_AT_cmd(at_pin, rep);
	MyGSM.send_AT_cmd(at_pin, rep);
	return setup();
	
}

void send_sms()
{
	
	m.clearScreen();
	m.textMode();
	m.textColor(WHITE);
	m.bgColor(RED);
	m.text(" Send SMS ", 4, 1);
	m.bgColor(BLACK);
	m.text("Number : +", 1, 4);
	m.cursor();
	m.moveCursorTo(12,4);	
	
	
	char num[20];
	char txt[160];
//	char *cmgs = "AT+CMGS=\"+";
//	char *endcmgs = "\"";
	char cmdcmgs[100];
	
	
//	strcpy(cmdcmgs, cmgs);
//	Serial.print(cmdcmgs);
//	send_AT_cmd("AT+CGATT?\r");
	saisieNum(num);
	saisieTxt(txt);
//	Serial.print(num);
//	strcat(cmdcmgs, num);
//	Serial.print(cmdcmgs);
//	strcat(cmdcmgs, endcmgs);
	MyGSM.send_AT_cmd("AT+CMGF=1\r", rep);			//Mode texte pour SMS
	delay(100);
	sprintf(cmdcmgs, "AT+CMGS=\"+%s\"\r", num);
	MyGSM.send_AT_cmd(cmdcmgs, rep);
	MyGSM.send_AT_cmd(txt, rep);
		
	delay(1000);	
	
	return loop();
	
}


void saisieNum(char *num) {
	int strCount = 0;
	
	while(1) {
		if(m.available()>0) {
			char key = NULL;
			// Obligation de lire 2 buffer en cas de touche Menu
			key = m.getKey();
			if(key != NULL) {
				if (m.isMenuKey() == true) { 
					key = m.getKey();
					if (key == '8') {
						/**** AJOUTER LE CHAR FIN DE COM MANDE AT PUIS PASSER SAISIE MESSAGES ****/
						num[strCount]='\0';
						return;
					}
				}
				else {
					m.textChar(key);		//print sur minitel
//					Serial.print(key);		//print sur le prompt
					num[strCount] = key;
					strCount++;
					strCount%=19;

				}
			}
		}
	}
}



void saisieTxt(char *txt) {
	int strCount = 0;
	m.text("Message : ", 1, 6);
	m.moveCursorTo(1,7);
	/*** COMMANDE ATM ***/
	while(1) {
		if(m.available()>0) {
			char key = NULL;
			// Obligation de lire 2 buffer en cas de touche Menu
			key = m.getKey();
				if(key != NULL) {
				if (m.isMenuKey() == true) { 
					key = m.getKey();
					if (key == '8') {
						txt[strCount]='\x1a';
						txt[strCount+1]='\r';
						txt[strCount+2]='\0';
						return;
					}
				}
				else {
					m.textChar(key);
					txt[strCount] = key;
					strCount++;
					strCount%=159;
					
				}
			}
		}
	}	
}



void saisiePin(char *pin) {
	int strCount = 0;
	
	while(1) {
		if(m.available()>0) {
			char key = NULL;
			// Obligation de lire 2 buffer en cas de touche Menu
			key = m.getKey();
			if(key != NULL) {
				if (m.isMenuKey() == true) { 
					key = m.getKey();
					if (key == '8') {
						/**** AJOUTER LE CHAR FIN DE COM MANDE AT PUIS PASSER SAISIE MESSAGES ****/
						pin[strCount]='\0';
						return;
					}
				}
				else {
					m.textChar('*');		//print sur minitel
//					Serial.print(key);		//print sur le prompt
					pin[strCount] = key;
					strCount++;
					strCount%=19;

				}
			}
		}
	}
}

void call_number() {
	m.clearScreen();
	m.textMode();
	m.textColor(WHITE);
	m.bgColor(RED);
	m.text(" Calling system ", 4, 1);
	m.bgColor(BLACK);
	m.text("Number : +", 1, 4);
	m.cursor();
	m.moveCursorTo(12,4);	
	
	
	char num[20];
	char txt[160];
	char cmdcmgs[100];
	saisieNum(num);
	sprintf(cmdcmgs, "ATD+%s;\r", num);
	MyGSM.send_AT_cmd(cmdcmgs, rep);
	MyGSM.send_AT_cmd(txt, rep);
		
	delay(1000);	
	
	return loop();
	
}
